#!/usr/bin/perl -w
#
# people.cgi
#
# Version 0.7.2 IB 991205
#    replaced exmysql and tomysql with exdbi and todbi, respectively
# Version 0.7.1 IB 991129
#    major cleanup
# SH Major Version whatever many many many rewrites 
# SH will fill in later what i did
#

$script_version="Version 0.7.1 - 991128";

## determine path from store root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om/admin,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$storeshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $storeshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $storeshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

## setup localization information
#
require "$relpath/lib/conversions.pm";
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/conf/store.pm";
require "$relpath/lib/validate.pm";

use DBI;

## establish store-specific parameters
#
$site=setstore();

## done with pull-from-file bits, rest of global settings...
#
$x= (split /\?/, $ENV{'REQUEST_URI'})[0];   # strip get stuff
@temp=split /\//, $x;

@temp=("cgi-bin","test","people.cgi") if (! $ENV{'REQUEST_URI'} );

$script=( split /\./, $scriptname )[0];
$n= $#temp - 1;
$scriptpath = join "/", ( @temp[0..$n] );
$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/admin";
$selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site/sel";

## determine if testmode or not
#
$testmode=1;

## filled in with time/context variable info
$nicedt=nicedatetime();

## construct some shorthands
$script_html = join "-", ($site->{'storeshortname'},$script,"");

## connect to database
# system 6 database state, products, and customer tables are collapsed
#
$db_con_products="DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
$dbh = DBI->connect( $db_con_products, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );

## get form data, if any was submitted
#
%FORM=();
&ReadParse();

$sid=$FORM{'sid'};

## start the replacements hash
#
%NVP=();
$NVP{'storename'}=$storename;
@skuvars=();       # array of hashrefs for holding sku variants
@skulinks=();      # array of hashrefs for holding linkages

$spine=loadtemplate("openmerchant-people-spine",$skeletonpath);

## catch inbounds lacking mode - homepage default
#
# the following names will be changed later, promise


#mode handling

if (! $FORM{'mode'}) {
   $FORM{'mode'}="home";
}

## login control
#
$FORM{'sid_ok'} = check_login($script,$FORM{'mode'},$FORM{'sid'});

if ( $testmode ) {
   open( FH, ">>/tmp/$scriptname");
   print FH "FORM sid_ok is $FORM{'sid_ok'} \n";
   close(FH);
}
if ( $FORM{'sid_ok'} ) {
   if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
      ## hard error, redirected to login page
      exit 0 ; 
   } elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
      ## soft error, send to default mode
      $FORM{'mode'}="home";
      $NVP{'__PAGE_ERROR_MSG__'}=$FORM{'sid_ok'};
   } else {
      ## welcome to the page...
   }   
   print "Content-type: text/html\n\n";
} else {
   ## unknown why sid_ok not populated with some string...
   #
   print "Content-type: text/html\n\n";
   print "<HTML><HEAD></HREAD><BODY>\n";
   print "$FORM{'sid'} sid evaluates as $FORM{'sid_ok'} \n";
   print "</BODY></HTML>\n";
   exit 0;
}

## Define first entries in %NVP based on mode, sid, etc...
#
$NVP{'sid'}=$FORM{'sid'};
$NVP{'lastmode'}=$FORM{'mode'};
$NVP{'script'}="$scriptpath/$scriptname";
$NVP{'datetime'}=$nicedt;
$NVP{'scriptpath'}=$scriptpath;


# check to see if the homepage is simply clearing the form
if (($FORM{'searchclear'}) and ($FORM{'mode'} eq "find")) {
   $FORM{'mode'}="home";
} #

# real preprocessing

if ($FORM{'mode'} eq "find") {
   # perform a search against the database
   #
   ## cleanup submitted data
  
   chomp $FORM{'person'};
   chomp $FORM{'CUSTKIND'};

   $x=length($FORM{'person'});
   $x+=length($FORM{'CUSTKIND'});

   if ($x>=2) {
     
     $query = "SELECT UNAME,UID,CUSTKIND,UPERM,PASSWD,";
      $query .="HINT from contacts ";
      $query .="WHERE ";
      $flag=0;
      if ( length($FORM{'person'})>1 ) {
         $query .="( UNAME LIKE '\%$FORM{'person'}\%' OR ";
         $query .="UID  LIKE '\%$FORM{'person'}\%' )";
         $flag=1;
      }
      if ( length($FORM{'CUSTKIND'})>1 ) {
         $query.="( CUSTKIND='$FORM{'CUSTKIND'}' )";
         $flag=1;
      } 
      $query .=" ORDER BY UNAME ";
     
      $sth = $dbh->prepare( $query );
      $sth->execute;
      $num = $sth->rows;
      $num=0 if (! $num);
      $num=0 if ($num < 0);

      if ( ! $num ) {
         # the query returned nothing
         $FORM{'mode'}='home';
         # push error message into page error message 
         $errm="Nothing found! Please try a simpler search";
         $NVP{'PAGE_ERROR_MSG'}=$errm;
         $NVP{'person_prev'}=$FORM{'person'};
      } elsif ( $num==1 ) {
         # exactly one row returned
         # --> send directly to appropriate editor routine
         @row=$sth->fetchrow;
         $FORM{'mode'}="edit";      
         $FORM{'loadfrom'}="db";    
         $NVP{'person_prev'}=$FORM{'person'};
         $NVP{'SKU'}=$row[0];
         $FORM{'SKU'}=$row[0];
      } else {
         # more than one row returned, show list of skus
         # and allow selection based on that
         #
         # read out skus and stash relevant bits in array
         #
         $FORM{'mode'}="searchlist";
         $FORM{'query'}=$query;
      }
      $sth->finish;
   } else {
      $FORM{'mode'}="home";
      $NVP{'person_prev'}=$FORM{'person'};
      $errm="Error - your search for $FORM{'person'} returned no skus<BR>Try searching on a smaller portion of the sku";
      $NVP{'PAGE_ERROR_MSG'}=$errm;
   }
} 
if ($FORM{'mode'} eq "edit" ) {
 
   if ( $FORM{'loadfrom'} eq "db" ) {
     &loadskufromdb($FORM{'person'});
   
   } elsif ( $FORM{'loadfrom'} eq "form" ) {
      &checkformbits();
   } 
 

   ## done loading data into the %FORM hash
   #  now run through error checking
   $okdata=validatefields();
   
   #
   ## now run decision trees based on 'loadfrom' and $okdata
   #
   if ( $okdata ) {

      if ( $FORM{'loadfrom'} eq "form" ) {
         # this is a form submission, data can be written
	  if (!$FORM{'UID'}) {$FORM{'UID'}=$FORM{'UID_inp'}};
	  $x=writeskutodb($FORM{'UID'});
         $personlink="<A HREF=people.cgi";
   $personlink.="\?\&mode=find&person=$FORM{'UID'}&sid=$FORM{'sid'}\>$FORM{'UID'}</A>";
        
      if ( $FORM{'newflag'} =~ /y/i ) {
            $NVP{'lastaction'}="Person $personlink Created Successfully!";
      } else {
            $NVP{'lastaction'}="Submitted changes to person $personlink <BR>";
      }
      $FORM{'mode'}="edit" if ($x);
     } #end of if eq "form"
   }  #end okdata

} #end edit
 
$targ=$storeshortname."-".$script."-".$FORM{'mode'};
print STDERR "looking for $storeshortname $targ \n";

########################################################
## Primary Display Mode Handling

if ($FORM{'mode'} eq "searchlist") {
   &printsearch;

} elsif ( $FORM{'mode'} eq "edit" ) {

   &writetonvp;          # push the form data to %NVP
  
   
   if ( $FORM{'newflag'} eq "Y" ) {
      $pagetitle="Creation of a New Person";
      $NVP{'newflag'}="Y";
   } else {
      $pagetitle="Editing $FORM{'person'} ";
   }
   $NVP{'pagetitle'}=$pagetitle;
   $NVP{'loadfrom'}="form";

   ## html-safe encode all of %NVP before pulldown generation
   foreach ( keys %NVP ) {
      $NVP{$_} = string_tohtml( $NVP{$_} );
   }
   
   ## Generate the Select Pulldowns 
   #
   foreach ( 'CUSTKIND|5', 'CUSTSTATUS|2') {
      local($k,$v,$x,@raw);
      ( $k,$v) = split /\|/, $_;
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( $FORM{$x},$v,@raw );
   } # done with new/existing pulldown choice
   

   # process the template file and dump to stdout
   
   if (!$NVP{'lastaction'}) { 
   
      $l = loadtemplate ( $targ, $skeletonpath );
      $l = permutebit( $l, \%NVP );
   
      $l=~ s/<\!--#include virtual=\"openmerchant-people-spine.html\"-->/$spine/gms;
      $l=~ s/__CUSTKIND_SELECT__/$NVP{'CUSTKIND_SELECT'}/gms;
      $l=~ s/__CUSTSTATUS_SELECT__/$NVP{'CUSTSTATUS_SELECT'}/gms;  
      $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
      $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
      $l=~ s/__storename__/$storename/gms;
      $l=~ s/__sid__/$sid/gms;
      $l=~ s/__mode__/$FORM{'mode'}/gms;
   
   
      $l = permuteclean($l);
      print $l;
   }

} elsif ($FORM{'mode'} eq "home" ) {
   #  'home' mode 
   ## DEFAULT PAGE
   #

   ## Generate the Select Pulldowns 
   #
   foreach ( 'CUSTKIND|5', 'CUSTSTATUS|2') {
      local($k,$v,$x,@raw);
      ( $k,$v) = split /\|/, $_;
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( "",$v,@raw );
   }
   
   $NVP{'script_version'}=$script_version;
   $l = loadtemplate( $targ , $skeletonpath );
   $l = permutebit( $l, \%NVP );
   $spine=loadtemplate("openmerchant-people-homespine", $skeletonpath);
   $l=~ s/<\!--#include virtual=\"openmerchant-people-homespine.html\"-->/$spine/gms;
   $l=~ s/__script__/$scriptpath\/$script.cgi/gms; 
   $l=~ s/__CUSTKIND_SELECT__/$NVP{'CUSTKIND_SELECT'}/gms;
   $l=~ s/__CUSTSTATUS_SELECT__/$NVP{'CUSTSTATUS_SELECT'}/gms;
   $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
   $l=~ s/__storename__/$storename/gms;
   $l=~ s/__sid__/$sid/gms;
   $l=~ s/__mode__/$FORM{'mode'}/gms;
   $l = permuteclean($l);
   print $l; 

}

`$site->{'fsrootcron'}/generate_temps.pl opensales_org`;    # regenerate the temps


if ($NVP{'lastaction'}) {

   $NVP{'script'} = "/cgi-bin/om/admin/people.cgi?mode=home";
   $targ=$storeshortname."-people-home";
   $l = loadtemplate($targ, $skeletonpath);
   $l=permutebit($l, \%NVP);

   $spine=loadtemplate("openmerchant-people-homespine", $skeletonpath);
   $l=~ s/<\!--#include virtual=\"openmerchant-people-homespine.html\"-->/$spine/gms;
   $l=~ s/__CUSTKIND_SELECT__/$NVP{'CUSTKIND_SELECT'}/gms;
   $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
   $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
   $l=~ s/__storename__/$storename/gms;
   $l=~ s/__sid__/$sid/gms;
   $l=~ s/__mode__/$FORM{'mode'}/gms;

   $l = permuteclean($l);
   print $l;

}

$dbh->disconnect if ( $dbh );


######################################################
## subroutines
##
######################################################

##### validatefields
#        takes all %FORM entries, seeks _inp entries, and 
#        performs field-by-field validation, with 
#        generation of _err error messages in %FORM as needed
#     returns 1 for OK, 0 for errors
#        - run after checkformbits
#        - does not need explicit fieldlist
#     Version 1 RF 981123
sub validatefields {
   # reads global %FORM
   my(@keys,$k,$e,$rv);
   $rv=1;                  # default OK, to 0 if error
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      next if ( $k !~ /_inp$/ );
      $kt = $k;
      $kt =~ s/_inp$// ;
      next if ( $kt =~ /[a-z]/ );   # fields are all uppercase
      $e=validatefield( $kt,$FORM{$k}, \%FORM );
      if ($kt eq "UID") {
	  $q = "select * from contacts where UID='$FORM{$k}' ";
	  $sth=$dbh->prepare($q);
	  $sth->execute;
	  $num = $sth->rows;
	  if ($num > 0 && $FORM{'newflag'} =~ /y/i) {$e = "Sorry, this uid has already been taken";}
      }
      if ($e) {
         $rv=0;           # there was an error returned
         $kt.="_err";
         $FORM{$kt}=$e;   # emplace the error message 
      } # done checking for a returned error
   } # done running through form keys 

   
   return $rv;
} #/validatefields


##### checkformbits - checks population of _inp, does not touch
#        NVP hash
#
sub checkformbits {
   # goes through global %FORM
   #
   my($k,$kt,@keys);
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      next if ( $k =~ /_ini$/ );   # nothing to do with ini
      if ( $k =~ /_pre$/ ) {
         # check to see if the inp key exists
         # if it doesn't exist, then create and set to _pre
         $kt=$k;
         $kt =~ s/_pre$/_inp/ ;
         $FORM{$kt}=$FORM{$k} if ( ! exists($FORM{$kt}) );
      } # only really concerned with _pre/_inp pairs
   } # done with all keys

   return 1;
} #/checkformbits

##### writetonvp - write form data to NVP hash
sub writetonvp {
   # could rewrite to take a hashref
   my(@keys,$k,$kt);
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      $kt = $k;
      $kt =~ s/(_ini|_inp|_pre|_err)$// ;
      if ( $k =~ /_inp$/ ) {           # _inp -> _pre
         $kt.="_pre";
         $NVP{$kt}=$FORM{$k};
      } elsif ( $k =~ /_ini$/ ) {      # _ini -> _ini
         $NVP{$k}=$FORM{$k};
      } elsif ( $k =~ /_err$/ ) {      # _err -> _err
         $NVP{$k}=$FORM{$k};
      } elsif ( $k eq $kt ) {          # X -> X
         if (( $kt !~ /[a-z]/ ) and ( ! exists($NVP{$kt}) )) {
            # this looks like a fieldname and is not yet set
            $NVP{$kt}=$FORM{$kt} if ( $FORM{$kt} );
         }
      } # any other inheritance modes?
   } # done running through form keys
   ## special cases
   #
  
   return 1; 
} #/writetonvp

##### LoadSkuFromDb
sub loadskufromdb {


   $q = 'SELECT * from contacts';
   $q.= " WHERE UID='$FORM{'person'}' OR UNAME='$FORM{'person'}' ";
   $sth = $dbh->prepare( $q );
   $sth->execute;
   $num = $sth->rows;
   if ( $num==1 ) {
       # query returned exactly one record
      $h = $sth->fetchrow_hashref;
      foreach (keys %{$h} ) {
         $x = string_exdbi($h->{$_});
         $kt=$_."_inp";
         $FORM{$kt}=$x if ( ! exists($FORM{$kt}) );
      } 
   } else {
      # there was an error!
      # send back to homepage with error message
      $FORM{'mode'}="home";
   }
   $sth->finish;
   return 1;
}
# /loadskufromdb

##### WriteSKUtoDB
#        version 2 - 981123
#        takes sku data from %FORM{_inp|X} entries
sub writeskutodb {
 
   my ($rv, $fields_contacts);
   my (%contacts, $q, $e, $sth, $ste);

   $rv="";      # return value, blank is good
  
   $now=time();

   if ($FORM{'newflag'} =~ /y/i) {$action="Create";} else {$action="Modify";}

   $dvalue=$FORM{'UID_inp'}."\t".$action;
   $dvaluecreate=$FORM{'UID_inp'}."\t"."Create";

   $e = "insert into levents (DTABLE, DVALUE, CDATE) values('contacts','$dvalue',$now)";
   $ste=$dbh->prepare($e);
   $ste->execute;

   $e="select event, series from levents where DTABLE='contacts' and DVALUE='$dvaluecreate' ";
   $ste=$dbh->prepare($e);
   $ste->execute;
   $num=$ste->rows;
   for (1..$num) {
      ($custnum, $series) = $ste->fetchrow;
   }
   $custnum = $custnum."-".$series;
 
   if ( ! $rv ) {
    
      $q=" SELECT * from contacts ";
      $sth = $dbh->prepare( $q );
      $sth->execute;
      $num = $sth->rows;
      if ($num>0) {
         $h = $sth->fetchrow_hashref;
      } else {
         $h={};
      }
  
      $fields_contacts = join ',', ( keys %{$h} );
      
      ## get fields in variants
      #

      %contacts=();
      

      foreach ( keys %FORM ) {
         next if ( $_ !~ /_inp$/ );
         next if ( $_ =~ /^SKU$/ );
         $k=$_;
         $kt=$k;
         $kt=~ s/_inp$// ;
         next if ( $kt =~ /[a-z]/ );          # no lowercase in fields
         if ( $fields_contacts =~ /$kt/ ) {      # product field
            $contacts{$kt} = $FORM{$k};
         }
      }
      ## now have fields split out into target tables
      #
      $contacts{'STATUS'}=$FORM{'CUSTSTATUS_inp'};
      
      $r="select * from contacts where UID='$FORM{'UID'}' ";
      $str=$dbh->prepare($r);
      $str->execute;
      $rnum=$str->rows;

      if ($rows == 0) {
	  $t = "insert into contacts (custnum, status) values('$custnum','$FORM{'CUSTSTATUS_inp'}' )";
	  $stt=$dbh->prepare($t);
	  $stt->execute;
      } 

      # update products first
      $q="";
      foreach ( keys %contacts ) {
         $q.="," if ( $q );
         $q.=$_."='".string_todbi($contacts{$_})."'";
	 if ($_ eq "PASSWD") {$password=$contacts{$_}; $sub="PASSWD=PASSWORD('".$password."')"; }

      }
      if ($q) {
         $q.=",MDATE=$now";                  # add a timestamp  

	
         $q = "UPDATE contacts SET $q WHERE CUSTNUM='$custnum' ";
	  $q =~ s/PASSWD='$password'/$sub/gms;
         $dbh->do( $q );  
      } 

   } # end of write cycle

   return $rv;
} #/writeskutodb

##### PrintSearch
sub printsearch {
   
   $expand1="";
   $expand2="";
   $expand3="";
   $expand4="";
   $query = $FORM{'query'};
   $sth = $dbh->prepare ( $query );
   $sth->execute;
   $num = $sth->rows;

   ## parse out the template
   # 
   $FORM{'storename'}=$storename;
   $FORM{'searchnum'}=$num;
   $FORM{'personname'}=$sochname;
   $FORM{'lastmode'}=$FORM{'mode'};
   $FORM{'scriptname'}="$scriptname";
   $FORM{'scriptpath'}="$scriptpath";

     

   ## call out page and cell templates
   #

   foreach ( 'CUSTKIND|5', 'CUSTSTATUS|2') {
      local($k,$v,$x,@raw);
      ( $k,$v) = split /\|/, $_;
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( "",$v,@raw );
   } 

   $thispage=loadtemplate($targ,$skeletonpath);



   ## output the file
   #
  

   ## put session data in $v for GET URL construction
   #
   $v="&sid=$sid&mode=edit&loadfrom=db";
   
   while ($num>0) {
      %row=%{$sth->fetchrow_hashref};
      $row{'UNAME'}=string_exdbi($row{'UNAME'});
      $k="person=$row{'UID'}";
      $expand1.="<TR><TD>";
      $expand1.="<A HREF=\"$scriptpath/$scriptname\?$v&$k\"><B>$row{'UID'}</B></A><BR></TD>";
      if ($row{'UNAME'}) { 
         $expand1.=" <TD>$row{'UNAME'} </TD>";
      } else {
         $expand1.="<TD>N/A</TD>";
      }
      $expand1.="<TD><A HREF=\"$scriptpath/$scriptname\?$v&$k\">password</A></TD>";
     
      $expand1.="</TR>";

      $num--;
   }
   $FORM{'column_215_1'}=$expand1;
    
   $FORM{'script'}="people.cgi";

   $thispage = permutebit( $thispage, \%FORM );
   $thispage=~ s/<\!--#include virtual=\"openmerchant-people-spine.html\"-->/$spine/gms;
   $thispage=~ s/__CUSTKIND_SELECT__/$NVP{'CUSTKIND_SELECT'}/gms;
   $thispage=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
   $thispage=~ s/__script__/$FORM{'script'}/gms; 
   $thispage=~ s/__storename__/$storename/gms;
   $thispage=~ s/__sid__/$sid/gms;
   $thispage=~ s/__mode__/$FORM{'mode'}/gms;

   $thispage = permuteclean ( $thispage );
   print $thispage;
   print $glenn; 

   $sth->finish;
   return 1;
} 

1;
